/***************************************************************************
 *   Copyright (C) 2005-2006 Gao Xianchao                                  *
 *                 2007 Gao Xianchao gnap_an linux_lyb ahlongxp            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
 * Author:	gxcoo
 * Create date:	2004-03-06 15:20
 */

#ifndef _BSTRING_H_
#define _BSTRING_H_

#include<string>
#include<cstdlib>

class CBString:public CBObject
{
public:
	CBString(void)
		:CBObject(2)
		{};
	~CBString(void){};
private:
	std::string m_value;
public:
	std::string getValue(void)
	{
		return m_value;
	};
	int parse(const char* buf,unsigned long bufLen)
	{
		int result=-1;
		int i=0;

		m_value.clear();
		while(isdigit(buf[i]))
		{
			++i;
		}
		if(buf[i]==':')
		{
			char* temp=new char[i+1];
			strncpy(temp,buf,i);
			temp[i]='\0';
			unsigned int strLen=atoi(temp);
			if(bufLen>=i+1+strLen)
			{
				m_value.append(&buf[i+1],strLen);
				result=i+1+strLen;
			}
		}
		return result;
	};
	
	void get_bestr(std::string& str)
	{
		char buf[128];
		memset(buf,0,sizeof(buf));
		sprintf(buf,"%u:",m_value.length());
		str+=buf;
		str+=m_value;
	};
};

#endif
